<?php
/* Autor...:  */
/* Esquema.: SEG_SubSistema.xml */
/* Generado: 2020-08-18 04:21:30 */

/* Metodos de acceso a los campos de la tabla SEG_SubSistema */
abstract class BaseSEG_SubSistemaBN
{
    /* Campos de la tabla */
    private $s_IdSubSistema;    // IdSubSistema: ( no definido )
    private $s_SubSistemaDescripcion;    // SubSistemaDescripcion: ( no definido )
    private $s_SubSistemaDir;    // SubSistemaDir: ( no definido )
    private $s_TareaPrefijo;    // TareaPrefijo: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdSubSistema */
    public function setIdSubSistema( $s_IdSubSistema )
    {
        $this->s_IdSubSistema = $s_IdSubSistema;
    }

    /* Obtiene el valor del campo IdSubSistema */
    public function getIdSubSistema()
    {
        return $this->s_IdSubSistema;
    }

    /* Establece el valor del campo SubSistemaDescripcion */
    public function setSubSistemaDescripcion( $s_SubSistemaDescripcion )
    {
        $this->s_SubSistemaDescripcion = $s_SubSistemaDescripcion;
    }

    /* Obtiene el valor del campo SubSistemaDescripcion */
    public function getSubSistemaDescripcion()
    {
        return $this->s_SubSistemaDescripcion;
    }

    /* Establece el valor del campo SubSistemaDir */
    public function setSubSistemaDir( $s_SubSistemaDir )
    {
        $this->s_SubSistemaDir = $s_SubSistemaDir;
    }

    /* Obtiene el valor del campo SubSistemaDir */
    public function getSubSistemaDir()
    {
        return $this->s_SubSistemaDir;
    }

    /* Establece el valor del campo TareaPrefijo */
    public function setTareaPrefijo( $s_TareaPrefijo )
    {
        $this->s_TareaPrefijo = $s_TareaPrefijo;
    }

    /* Obtiene el valor del campo TareaPrefijo */
    public function getTareaPrefijo()
    {
        return $this->s_TareaPrefijo;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdSubSistema' => $this->getIdSubSistema(),
            'SubSistemaDescripcion' => $this->getSubSistemaDescripcion(),
            'SubSistemaDir' => $this->getSubSistemaDir(),
            'TareaPrefijo' => $this->getTareaPrefijo(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto SEG_SubSistemaBN desde un RecordSet */
    public static function retrieveByRs( $o_SEG_SubSistemaRs )
    {
        $o_SEG_SubSistemaBN = new SEG_SubSistemaBN();
        $o_SEG_SubSistemaBN->setIdSubSistema( $o_SEG_SubSistemaRs[ "IdSubSistema" ] );
        $o_SEG_SubSistemaBN->setSubSistemaDescripcion( $o_SEG_SubSistemaRs[ "SubSistemaDescripcion" ] );
        $o_SEG_SubSistemaBN->setSubSistemaDir( $o_SEG_SubSistemaRs[ "SubSistemaDir" ] );
        $o_SEG_SubSistemaBN->setTareaPrefijo( $o_SEG_SubSistemaRs[ "TareaPrefijo" ] );
        $o_SEG_SubSistemaBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_SEG_SubSistemaRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_SubSistemaBN->setUsuarioCreacion( $o_SEG_SubSistemaRs[ "UsuarioCreacion" ] );
        $o_SEG_SubSistemaBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_SEG_SubSistemaRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_SEG_SubSistemaBN->setUsuarioModificacion( $o_SEG_SubSistemaRs[ "UsuarioModificacion" ] );
        return $o_SEG_SubSistemaBN;
    }
}
?>